SystemOrganization addCategory: #'MemoryMentor-Tests'!
SystemOrganization addCategory: #'MemoryMentor-Visualization'!
SystemOrganization addCategory: #'MemoryMentor-Core'!

UiPropertyItemNode subclass: #MMTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMTask class methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:25:15.21'!
drawPointerArrow
	^ self named: 'Pointers 1'! !

!MMTask class methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:24:59.7'!
named: aName
	^ self new
		name: aName;
		yourself! !

!MMTask methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:05:17.152'!
isTask
	^ true! !

!MMTask methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:05:23.21'!
isTopic
	^ false! !

!MMTask methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:20:40.654'!
name
	^ self at: #name! !

!MMTask methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:21:08.99'!
name: aName
	self at: #name put: aName! !

UiPropertyItemNode subclass: #MMTopic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMTopic class methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:31:44.234'!
named: aName withTasks: tasks
	^ self new
		name: aName;
		addDefaultGroup;
		addTasks: tasks;
		yourself! !

!MMTopic class methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:29:45.424'!
objects
	^ self named: 'Objects' withTasks: {
		MMTask drawPointerArrow.
		MMTask drawPointerArrow.
		MMTask drawPointerArrow.
	}
	! !

!MMTopic class methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:29:35.432'!
pointers
	^ self named: 'Pointers' withTasks: {
		MMTask drawPointerArrow.
		MMTask drawPointerArrow.
		MMTask drawPointerArrow.
	}
	! !

!MMTopic methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:28:13.242'!
addTask: aTask
	self addChild: aTask! !

!MMTopic methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:28:38.142'!
addTasks: aTaskCollection
	aTaskCollection do: [ :task | self addTask: task ]! !

!MMTopic methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:05:34.136'!
isTask
	^ false! !

!MMTopic methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:05:38.716'!
isTopic
	^ true! !

!MMTopic methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:22:09.484'!
name
	^ self at: #name! !

!MMTopic methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:22:18.142'!
name: aName
	self at: #name put: aName! !

!Float class methodsFor: '*MemoryMentor-Core' stamp: 'lt 6/4/2013 18:28:54.799'!
fromIEEE64Bit: doubleWord
	"Convert the given 64 bit IEEE floating point representation into a Squeak float object (also being 64bit wide)."
	| sign newFloat |
	doubleWord negative ifTrue: [^ self error:'Cannot deal with negative numbers'].
	doubleWord = 0 ifTrue: [^ 0.0].
	sign := doubleWord bitAnd: 16r8000000000000000.
	doubleWord = sign ifTrue: [^self negativeZero].

	newFloat := self new: 2.
	newFloat basicAt: 1 put: (doubleWord bitShift: -32).
	newFloat basicAt: 2 put: (doubleWord bitAnd: 16rFFFFFFFF).
	^newFloat! !

!Float methodsFor: '*MemoryMentor-Core' stamp: 'WS 6/4/2013 16:49:34.092'!
asIEEE64BitDoubleWord
	"Convert the receiver into a 64 bit Integer value representing the same number in IEEE 64 bit format."
	
	^ ((self basicAt: 1) bitShift: 32) + (self basicAt: 2)! !

UserInterface subclass: #MMMemoryMentorUi
	instanceVariableNames: 'tasks workSpace taskDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryMentorUi methodsFor: 'ui - private' stamp: 'lt 6/5/2013 13:30:50.455'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	|  |
	
	panel := UiContainer new.
	panel changeProportionalLayout.
	panel extent: (651@585).
	panel position: (0@0).
	panel hResizing: (#spaceFill).
	panel vResizing: (#spaceFill).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color transparent).
	panel setProperty: #objectName toValue: 'panel'.
	tasks := UiTreeView new.
	tasks extent: (125@577).
	tasks position: (4@4).
	tasks hResizing: (#spaceFill).
	tasks vResizing: (#spaceFill).
	tasks minWidth: (2).
	tasks minHeight: (2).
	tasks cellInset: (0).
	tasks cellPositioning: (#center).
	tasks cellSpacing: (#none).
	tasks layoutInset: (0).
	tasks listCentering: (#topLeft).
	tasks listDirection: (#topToBottom).
	tasks listSpacing: (#none).
	tasks maxCellSize: (1073741823).
	tasks minCellSize: (0).
	tasks wrapCentering: (#topLeft).
	tasks wrapDirection: (#none).
	tasks frameFractions: (0@0 corner: 0.2@1).
	tasks frameOffsets: (2@2 corner: -2@ -2).
	tasks balloonText: (nil).
	tasks balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	tasks widgetResizable: (false).
	tasks horizontalScrollBarPolicy: (#asNeeded).
	tasks verticalScrollBarPolicy: (#asNeeded).
	tasks outerBorderWidth: (0).
	tasks scrollBarThickness: (9).
	tasks modelClass: (nil).
	tasks horizontalHeaderVisible: (true).
	tasks verticalHeaderVisible: (false).
	tasks selectionBehavior: (#selectRows).
	tasks selectionMode: (UiViewSingleSelection).
	tasks setProperty: #objectName toValue: 'tasks'.
	panel addChild: tasks.
	workSpace := UiScrollArea new.
	workSpace extent: (255@577).
	workSpace position: (392@4).
	workSpace hResizing: (#spaceFill).
	workSpace vResizing: (#spaceFill).
	workSpace minWidth: (2).
	workSpace minHeight: (2).
	workSpace cellInset: (0).
	workSpace cellPositioning: (#center).
	workSpace cellSpacing: (#none).
	workSpace layoutInset: (0).
	workSpace listCentering: (#topLeft).
	workSpace listDirection: (#topToBottom).
	workSpace listSpacing: (#none).
	workSpace maxCellSize: (1073741823).
	workSpace minCellSize: (0).
	workSpace wrapCentering: (#topLeft).
	workSpace wrapDirection: (#none).
	workSpace frameFractions: (0.6@0 corner: 1@1).
	workSpace frameOffsets: (2@2 corner: -2@ -2).
	workSpace balloonText: (nil).
	workSpace balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	workSpace widgetResizable: (false).
	workSpace horizontalScrollBarPolicy: (#alwaysOn).
	workSpace verticalScrollBarPolicy: (#alwaysOn).
	workSpace outerBorderWidth: (0).
	workSpace scrollBarThickness: (9).
	workSpace setProperty: #objectName toValue: 'workSpace'.
	panel addChild: workSpace.
	taskDescription := UiScrollArea new.
	taskDescription extent: (255@577).
	taskDescription position: (133@4).
	taskDescription hResizing: (#spaceFill).
	taskDescription vResizing: (#spaceFill).
	taskDescription minWidth: (2).
	taskDescription minHeight: (2).
	taskDescription cellInset: (0).
	taskDescription cellPositioning: (#center).
	taskDescription cellSpacing: (#none).
	taskDescription layoutInset: (0).
	taskDescription listCentering: (#topLeft).
	taskDescription listDirection: (#topToBottom).
	taskDescription listSpacing: (#none).
	taskDescription maxCellSize: (1073741823).
	taskDescription minCellSize: (0).
	taskDescription wrapCentering: (#topLeft).
	taskDescription wrapDirection: (#none).
	taskDescription frameFractions: (0.2@0 corner: 0.6@1).
	taskDescription frameOffsets: (2@2 corner: -2@ -2).
	taskDescription balloonText: (nil).
	taskDescription balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	taskDescription widgetResizable: (false).
	taskDescription horizontalScrollBarPolicy: (#alwaysOn).
	taskDescription verticalScrollBarPolicy: (#alwaysOn).
	taskDescription outerBorderWidth: (0).
	taskDescription scrollBarThickness: (9).
	taskDescription setProperty: #objectName toValue: 'taskDescription'.
	panel addChild: taskDescription.
	panel setProperty: #uiClassName toValue: 'MMMemoryMentor'.! !

!MMMemoryMentorUi methodsFor: 'accessing' stamp: 'lt 6/5/2013 13:30:50.443'!
taskDescription
	"No description given."
	
	^ taskDescription! !

!MMMemoryMentorUi methodsFor: 'accessing' stamp: 'lt 6/5/2013 13:30:50.432'!
tasks
	"No description given."
	
	^ tasks! !

!MMMemoryMentorUi methodsFor: 'accessing' stamp: 'lt 6/5/2013 13:30:50.439'!
workSpace
	"No description given."
	
	^ workSpace! !

Morph subclass: #MMCellGroupMorph
	instanceVariableNames: 'cells type displayMode valueMorphs contextMenu memoryMorph pointerArrow isShowingBits horizontalContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

MMCellGroupMorph class
	instanceVariableNames: 'typeToValidDisplayModes symbolsToMenuString'!

MMCellGroupMorph class
	instanceVariableNames: 'typeToValidDisplayModes symbolsToMenuString'!

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:00:07.126'!
bitsReadTypeForType: aSymbol
	(self oneByteTypes includes: aSymbol)
		ifTrue: [^ #raw].

	^ (self eightByteTypes includes: aSymbol)
		ifTrue: [#ulong]
		ifFalse: [#uint]! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/3/2013 15:34:39.221'!
byteHeight
	^ TextStyle default defaultFont height + 6! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 10:56:40.498'!
byteLengthOfType: aSymbol
	^ true caseOf: {
		[(self oneByteTypes includes: aSymbol)] -> [1].
		[(self fourByteTypes includes: aSymbol)] -> [4].
		[(self eightByteTypes includes: aSymbol)] -> [8].
	}! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:11:09.818'!
byteWidth
	^ (TextStyle default defaultFont widthOf: $0) * (8+4)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:23:29.159'!
contentMorphWidthForType: aSymbol
	| widthFactor |
	widthFactor := (self oneByteTypes includes: aSymbol) 
		ifTrue: [1] 
		ifFalse: [4].
	
	^ self byteWidth * widthFactor! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 10:43:54.146'!
defaultDisplayMode
	^ #hexadecimal
	! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:15:05.714'!
defaultWidth
	^ self byteWidth * 4! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 10:53:49.963'!
eightByteTypes
	^ #(pointer long ulong double)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:57:35.886'!
for: cellOrCells in: aMemoryMorph
	 ^ self new
		memoryMorph: aMemoryMorph;
		cells: cellOrCells;
		setup! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 10:59:00.841'!
fourByteTypes
	^ #(int uint float)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'WS 5/29/2013 11:05:48.856'!
invalidateValidDisplayModes
	typeToValidDisplayModes := nil! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 10:53:34.311'!
oneByteTypes
	^ #(raw char uchar bool)! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'WS 5/29/2013 11:13:02.922'!
symbolsToMenuString
	symbolsToMenuString ifNil: [
		symbolsToMenuString := Dictionary newFrom: {
			#binary -> 'Binary'.
			#decimal -> 'Decimal'.
			#hexadecimal -> 'Hexadecimal'.
			#ascii -> 'ASCII'.
			#raw -> 'Raw'.
			#pointer -> 'Pointer'.
			#int -> 'Integer'.
			#uint -> 'Unsigned Integer'.
			#long -> 'Long'.
			#ulong -> 'Unsigned Long'.
			#char -> 'Character'.
			#uchar -> 'Unsigned Character'.
			#float -> 'Float'.
			#double -> 'Double'
		}
	].
	
	^ symbolsToMenuString! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'WS 5/29/2013 11:21:35.276'!
typeToValidDisplayModes
	typeToValidDisplayModes ifNil: [
		typeToValidDisplayModes := {
			#raw -> #(hexadecimal binary decimal ascii).
			#pointer -> #(hexadecimal).
			#int -> #(decimal binary hexadecimal).
			#uint -> #(decimal binary hexadecimal).
			#long -> #(decimal binary hexadecimal).
			#ulong -> #(decimal binary hexadecimal).
			#char -> #(ascii binary decimal hexadecimal).
			#uchar -> #(decimal binary hexadecimal).
			#float -> #(decimal).
			#double -> #(decimal)
		}
	].
	
	^ typeToValidDisplayModes! !

!MMCellGroupMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:13:28.695'!
widthForBytes: aNumber
	^ self byteWidth * aNumber! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:51:55.534'!
address
	^ cells first address! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:50:43.167'!
byteValueAt: address type: aSymbol
	^ self 
		contentValueAt: address 
		type: aSymbol! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 11:46:38.254'!
cells
	 ^ cells! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:14:47.492'!
cells: cellOrCells
	cells := cellOrCells isCollection
				ifTrue: [ cellOrCells ]
				ifFalse: [ Array with: cellOrCells ].
	self updateContent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:28:32.332'!
clearPointerArrow
	pointerArrow ifNotNil: [ pointerArrow remove ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:48:37.848'!
contentValueAt: address type: aSymbol
	^ aSymbol caseOf: {
		[ #pointer ] -> [ self memory ulongAt: address ].
		[ #long ] -> [ self memory longAt: address ].	
		[ #ulong ] -> [ self memory ulongAt: address ].
		[ #int ] -> [ self memory intAt: address ].
		[ #uint ] -> [ self memory uintAt: address ].
		[ #float ] -> [ self memory floatAt: address ].
		[ #double ] -> [ self memory doubleAt: address ].
		[ #char ] -> [ self memory charAt: address ].
		[ #uchar ] -> [ self memory ucharAt: address ].
		[ #bool ] -> [ self memory byteAt: address ].
		[ #raw ] -> [ self memory byteAt: address ].
	} otherwise: [ 0 ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:50:14.723'!
contentValueForType: aSymbol
	^ self 
		contentValueAt: self address 
		type: aSymbol  ! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:15:08.702'!
createAddressMorph
	| width labelMorph |
	width := (TextStyle default defaultFont widthOf: $0) * 
			(('0x', (cells first memory endAddress printStringBase: 16)) size + 1).
	labelMorph := MMMemoryAddressMorph forAddress: cells first address width: width height: self class byteHeight .
	"self updateTooltipWith: labelMorph addressString."
	^ labelMorph! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:24:13.492'!
createBitsMorphFor: numberValue byteLength: numberOfBytes
	^ MMBitsMorph
		content: numberValue
		extent: (self class contentMorphWidthForType: self type) @ (self class byteHeight)
		byteLength: numberOfBytes! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:59:54.355'!
createByteMorph: i of: aCell type: aSymbol
	| value bitsValue |
	value := self byteValueAt: aCell address + i type: aSymbol.
	bitsValue := (self byteValueAt: aCell address + i type: #raw).
	
	^ self createContentMorphFor: value withBits: bitsValue! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 13:53:37.173'!
createByteMorphs
	| byteMorphs |
	byteMorphs := OrderedCollection new.
	cells do: [ :cell | 0 to: 3 do: [ :i | 
			(byteMorphs add: (self createByteMorph: i of: cell type: type)) ]].
	^ byteMorphs! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:00:09.669'!
createCellMorph
	| value readType bitsValue |
	value := self contentValueForType: type.
	readType := self class bitsReadTypeForType: type.
	bitsValue := (self contentValueForType: readType).
	
	^ self createContentMorphFor: value withBits: bitsValue! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:00:41.784'!
createContent
	^ (self class oneByteTypes includes: type)
			ifTrue: [ self createByteMorphs ]
			ifFalse: [ {self createCellMorph} ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:59:37.885'!
createContentMorphFor: value withBits: bitsValue
	|interpretedValueMorph |
	interpretedValueMorph := self createValueMorphFor: value.
	valueMorphs add: interpretedValueMorph.
	
	^ self isShowingBits 
		ifTrue: [|bitsMorph innerContainerMorph|
			bitsMorph := self 
				createBitsMorphFor: bitsValue
				byteLength: (self class byteLengthOfType: type).
			innerContainerMorph := self innerVerticalContainerMorph
				addMorph: interpretedValueMorph;
				addMorph: bitsMorph;
				yourself.
			innerContainerMorph]
		ifFalse: [interpretedValueMorph]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 17:09:01.657'!
createContextMenu
	| displayModeMenu |
	displayModeMenu := MenuMorph new.
	self class typeToValidDisplayModes do: [ :each | | subMenu type displayModes |
		type := each key.
		displayModes := each value.
		
		subMenu := MenuMorph new.
		displayModes do: [ :displayMode |
			subMenu add: (self class symbolsToMenuString at: displayMode) target: self selector: #type:displayMode: argumentList: (Array with: type with: displayMode)
		].
		displayModeMenu add: (self class symbolsToMenuString at: type) subMenu: subMenu
	].
	
	^ MenuMorph new
		add: 'Interpret Memory as ...' subMenu: displayModeMenu;
		add: 'Retarget Pointer' target: self selector: #retargetPointer;
		addUpdating: #isShowingBitsMenuString target: self action: #toggleShowingBits;
		yourself.! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:16:56.505'!
createValueMorphFor: aNumber
	^ MMValueMorph 
		content: aNumber
		extent: (self class contentMorphWidthForType: self type) @ (self class byteHeight)
		displayMode: self displayMode! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:18:28.708'!
displayMode
	^ displayMode! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:16:33.652'!
displayMode: aSymbol
	displayMode := aSymbol.
	self displayModeChanged! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:16:28.098'!
displayModeChanged 
	valueMorphs do: [ :valueMorph | valueMorph displayMode: displayMode ]! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:13:06.829'!
horizontalContainerHeight
	^ self class byteHeight * cells size
		* (isShowingBits ifTrue: [ 2 ] ifFalse: [ 1 ])
! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:11:21.389'!
initialize 
	super initialize.
	contextMenu := self createContextMenu.
	valueMorphs := OrderedCollection new.
	type := #raw.
	isShowingBits := false.
	horizontalContainer := BorderedMorph new
		layoutPolicy: TableLayout new;
		color: (Color gray: 0.9);
		borderWidth: 1;
		hResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left;
		yourself.
	self
		displayMode: self class defaultDisplayMode;
		color: Color white;
		wantsYellowButtonMenu: true;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left.! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 17:41:12.541'!
innerVerticalContainerMorph
	^ Morph new
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		listCentering: #center;
		yourself! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 16:48:44.953'!
isShowingBits
	^ isShowingBits! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 16:54:15.335'!
isShowingBitsMenuString
	^ (isShowingBits 
		ifTrue: ['<yes>'] 
		ifFalse: ['<no>']), 'Also show bits'! !

!MMCellGroupMorph methodsFor: 'accessing' stamp: 'RL 5/22/2013 13:51:17.422'!
memory
	^ memoryMorph memory ! !

!MMCellGroupMorph methodsFor: 'accessing' stamp: 'RL 5/15/2013 14:36:58.93'!
memoryMorph
	^ memoryMorph! !

!MMCellGroupMorph methodsFor: 'accessing' stamp: 'RL 5/15/2013 14:36:58.94'!
memoryMorph: anObject
	memoryMorph := anObject! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:45:06.658'!
merge: size
	memoryMorph merge: self size: size! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:22:00.578'!
pointerArrow: aPointerArrow
	pointerArrow ifNotNil: [ pointerArrow remove ].
	pointerArrow := aPointerArrow! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/23/2013 13:50:46.647'!
retargetPointer
	self clearPointerArrow.
	MMPointerArrow from: self! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/23/2013 14:04:18.002'!
retargetPointerTo: anAddress
	| targetGroup |
	targetGroup := memoryMorph groupAtAddress: anAddress.
	targetGroup ifNil: [ ^ self ].
	
	MMPointerArrow from: self to: targetGroup! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:41:43.014'!
retargetedPointer: aMemoryCell
	self memory at: self address putULong: aMemoryCell address.
	self type: #pointer! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 17:23:52.228'!
setTypeTo: aSymbol
	| previousType newType |
	(type == aSymbol) ifTrue: [^ self].

	previousType := type.
	newType := aSymbol.
	
	(previousType == #pointer) ifTrue: [self clearPointerArrow]. 
	self type: aSymbol.
	(newType == #pointer) ifTrue: 
		[self retargetPointerTo: (self contentValueForType: #pointer)].! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:11:21.402'!
setup
	self
		addMorphBack: self createAddressMorph;
		addMorphBack: horizontalContainer;
		updateContent;
		extent: self fullBounds extent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:44:44.176'!
split
	memoryMorph split: self! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 17:12:16.565'!
toggleShowingBits
	isShowingBits := isShowingBits not.
	self updateContent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/3/2013 16:40:56.11'!
type
	^ type! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:17:16.374'!
type: aSymbol
	type := aSymbol.
	self typeChanged ! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/29/2013 11:19:02.336'!
type: typeSymbol displayMode: displayModeSymbol
	self type: typeSymbol.
	self displayMode: displayModeSymbol! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 17:36:51.091'!
typeChanged
	(self class eightByteTypes includes: type)
		ifTrue: [ self merge: 2 ]
		ifFalse: [ self split ].
		
	self updateContent! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:13:06.836'!
updateContent
	| contentMorphs |
	horizontalContainer submorphsDo: #delete.
	valueMorphs := OrderedCollection new.
	horizontalContainer height: self horizontalContainerHeight.
	contentMorphs := self createContent.
	horizontalContainer addMorphs: contentMorphs
! !

!MMCellGroupMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:05:26.422'!
yellowButtonActivity: shiftKeyState
	contextMenu popUpInWorld! !

Morph subclass: #MMMemoryAddressMorph
	instanceVariableNames: 'address stringMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryAddressMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:57:11.479'!
defaultFont 
	^ StrikeFont familyName: 'Bitmap Envy Code R' pointSize: 10 emphasized: 0! !

!MMMemoryAddressMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:59:09.436'!
forAddress: anInteger width: width height: height
	^ self new
		setAddress: anInteger
		width: width 
		height: height! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:58:21.63'!
address
	^ address! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:02:55.924'!
address: anInteger
	address := anInteger.
	
	self updateStringMorph! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:02:33.592'!
addressString
	 ^ '0x', (address printStringBase: 16)! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 12:04:46.127'!
setAddress: anInteger width: width height: height 
	self
		address: anInteger;
		color: Color white;
		extent: width@height;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #center.

	stringMorph := StringMorph contents: self addressString font: self class defaultFont.
	self addMorph: stringMorph.! !

!MMMemoryAddressMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:03:39.056'!
updateStringMorph
	stringMorph ifNil: [ ^ self ].
	
	stringMorph contents: self addressString! !

Morph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory groupMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryMorph commentStamp: 'RL 5/15/2013 14:38:05.526' prior: 0!
(MMMemoryMorph for: (MMMemory withStartAddress: 16r100 bytes:  #[104 101 108 108 111] cellCount: 20)) openInHand!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/3/2013 16:42:48.113'!
displayModeForRawMemory: aSymbol
	groupMorphs 
		select: [:each | each type == #raw]
		thenDo: [:each | each displayMode: aSymbol]! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/23/2013 11:20:08.776'!
groupAtAddress: anAddress
	^ groupMorphs 
		detect: [:each | each address = anAddress ]
		ifNone: [nil]! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/4/2013 17:38:50.948'!
initialize
	super initialize.
	
	groupMorphs := OrderedCollection new.
		
	self
		color: Color red;
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		wrapDirection: #topToBottom;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:52:34.346'!
memory
	^ memory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:53:07.046'!
merge: aGroup size: anInteger
	| index toSplit count i toMerge cells |
	index := groupMorphs indexOf: aGroup.
	
	toSplit := OrderedCollection new.
	count := 0.
	i := 0.
	[ count < anInteger ] whileTrue: [ | group |
		group := groupMorphs at: index + i ifAbsent: [ self error: 'caution!! you are about to leave the memory.' ].
		toSplit add: group.
		count := count + group cells size.
		i := i + 1.
	].
	toSplit do: [ :each | self split: each].
	
	toMerge := groupMorphs copyFrom: index to: index + anInteger - 1.
	cells := toMerge flatCollect: [ :group | group cells ].
	groupMorphs removeAll: toMerge.
	toMerge allButFirst do: #delete.
	toMerge first cells: cells.
	groupMorphs add: toMerge first beforeIndex: index.! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 14:40:06.682'!
setupMemory: aMemory
	memory := aMemory.
	memory cellsDo: [ :cell | | groupMorph |
		groupMorph := MMCellGroupMorph for: cell in: self.
		groupMorphs add: groupMorph.
	].
	self
		addMorphs: groupMorphs;
		extent: self fullBounds extent.! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 15:18:15.422'!
split: aGroup
	| index newGroups |
	index := groupMorphs indexOf: aGroup.
	newGroups := aGroup cells allButFirst collect: [ :cell | MMCellGroupMorph for: cell in: self ].
	aGroup cells: aGroup cells first.
	newGroups reverseDo: [ :group |
		group displayMode: aGroup displayMode.
		groupMorphs add: group afterIndex: index.
		self addMorph: group after: aGroup
	].
	! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 14:38:36.112'!
wantsYellowButtonMenu
	"Answer true if the receiver wants a yellow button menu"
	^ false! !

Morph subclass: #MMRightAngledArrow
	instanceVariableNames: 'from to spacing arrowBorderWidth points horizontalLungeDirection verticalLungeDirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:01:59.012'!
from: aPoint to: anotherPoint
	^ self from: aPoint to: anotherPoint spacing: 30! !

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:01:37.892'!
from: aPoint to: anotherPoint spacing: anInteger
	^ super new
		spacing: anInteger;
		initializeFrom: aPoint to: anotherPoint;
		yourself! !

!MMRightAngledArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:58:08.482'!
new
	^ self shouldNotImplement! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:41:07.756'!
arrowBoundsAt: endPoint from: priorPoint 
	"Answer a triangle oriented along the line from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v := endPoint - priorPoint.
	angle := v degrees.
	d := arrowBorderWidth max: 1.
	arrowSpec := self valueOfProperty: #arrowSpec ifAbsent: [5@4].
	length := arrowSpec x abs.  width := arrowSpec y abs.
	wingBase := endPoint + (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase + (Point r: d * width degrees: angle - 125.0) }]
		ifFalse: ["Negative length means concave base."
				^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase.
					wingBase + (Point r: d * width degrees: angle - 125.0) }]! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 11:47:34.906'!
bottomLunge
	^ 0 @ -1! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:46:08.27'!
drawArrowOn: canvas
	self assert: [ points size >= 2].
	
	points overlappingPairsDo:[ :p1 :p2 |
		canvas line: p1 to: p2 width: arrowBorderWidth color: Color black
	].
	canvas
		drawPolygon: (self arrowBoundsAt: points last from: (points at: points size - 1))
		color: Color white borderWidth: arrowBorderWidth borderColor: Color black! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:35:45.466'!
drawOn: aCanvas
	aCanvas
		translateBy: self owner position
		during: [ :canvas | self drawArrowOn: canvas ].! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:43:09.388'!
initialize
	super initialize.
	
	arrowBorderWidth := 2.
	spacing := 30.
	points := OrderedCollection new.
	horizontalLungeDirection := #right.
	verticalLungeDirection := #top! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:00:42.904'!
initializeFrom: aPoint to: anotherPoint
	| bounds |
	self assert: [ aPoint ~= anotherPoint ].
	
	from := aPoint.
	to := anotherPoint.
	self initializePoints.
	bounds := from rect: to.
	points do: [ :point | bounds := bounds encompass: point ].
	(self arrowBoundsAt: points last from: (points at: points size - 1)) do: [ :point | bounds := bounds encompass: point ].
	self bounds: (bounds outsetBy: arrowBorderWidth)! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:09:49.454'!
initializePoints
	from ifNil: [ ^ self ].
	to ifNil: [ ^ self ].
	
	points := OrderedCollection new.
	
	points add: from.
	
	true caseOf: {
		[ (from x - to x) abs >= spacing and: [ (from y - to y) abs >= spacing ] ] -> [
			(from x - to x) abs < (from y - to y) abs ifTrue: [
				points add: from x @ (from interpolateTo: to at: 0.5) y.
				points add: to x @ (from interpolateTo: to at: 0.5) y.
			] ifFalse: [
				points add: (from interpolateTo: to at: 0.5) x @ from y.
				points add: (from interpolateTo: to at: 0.5) x @ to y.
			]
		].
		[ (from x - to x) abs >= spacing and: [ (from y - to y) abs < spacing ] ] -> [ | tempY |
			tempY := verticalLungeDirection == #top ifTrue: [ (from y max: to y) + spacing ] ifFalse: [ (from y min: to y) - spacing ].
			points add: from x @ tempY.
			points add: to x @ tempY
		].
		[ (from x - to x) abs < spacing and: [ (from y - to y) abs >= spacing ] ] -> [ | tempX |
			tempX := horizontalLungeDirection == #left ifTrue: [ (from x min: to x) - spacing ] ifFalse: [ (from x max: to x) + spacing ].
			points add: tempX @ from y.
			points add: tempX @ to y
		].
		[ (from x - to x) abs < spacing and: [ (from y - to y) abs < spacing ] ] -> [
			"straight line, so add no points"
		]
	}.
	
	points add: to! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 13:58:35.68'!
points
	^ points! !

!MMRightAngledArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:00:25.938'!
spacing: anInteger
	spacing := anInteger.
	
	self initializePoints! !

Morph subclass: #MMToolTippedMorph
	instanceVariableNames: 'tooltip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:06:17.438'!
createTooltip
	tooltip := BorderedMorph new.
	tooltip
		color: Color yellow muchLighter paler;
		borderWidth: 1.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:03:13.85'!
handlesMouseMove: event
	^ true! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:32.461'!
hideTooltip
	tooltip delete.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:08:21.123'!
initialize
	super initialize.
	self 
		createTooltip;
		initializeEvents.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:29.41'!
initializeEvents
	self on: #mouseEnter send: #mouseEnter to: self.
	self on: #mouseMove send: #moveTooltip to: self.
	self on: #mouseLeave send: #mouseLeave to: self.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:19.744'!
mouseEnter
	self addAlarm: #showTooltip after: 1000.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:51:09.543'!
mouseLeave
	self removeAlarm: #showTooltip.
	self hideTooltip.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:51.349'!
moveTooltip
	tooltip position: ActiveHand center.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 10:50:25.524'!
showTooltip
	tooltip position: ActiveHand center.
	World addMorph: tooltip.
	tooltip fadeIn.! !

!MMToolTippedMorph methodsFor: 'as yet unclassified' stamp: 'lt 5/13/2013 13:08:24.159'!
updateTooltipWith: aMessage
	tooltip
		removeAllMorphs;
		addMorph: (StringMorph new contents: aMessage; yourself);
		bounds: tooltip fullBounds.! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:12:51.548'!
boolAt: index
	^ (self byteAt: index) ~= 0! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:14:02.732'!
boolAt: index put: boolean
	^ self byteAt: index put: (boolean ifTrue: [ 1 ] ifFalse: [ 0 ])! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:29:12.98'!
charAt: index
	^ self byteAt: index! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:16:11.336'!
charAt: index put: aCharacter
	^ self byteAt: index put: aCharacter asInteger! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'lt 5/31/2013 11:29:12.65'!
doubleAt: index
	^ Float fromIEEE64Bit: (self ulongAt: index)! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'WS 6/4/2013 16:30:01.668'!
doubleAt: index put: aDouble
	self ulongAt: index put: aDouble asIEEE64BitDoubleWord! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 14:12:08.302'!
floatAt: index
	^ Float fromIEEE32Bit: (self uintAt: index)! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:32:53.82'!
floatAt: index put: aFloat
	self uintAt: index put: aFloat asIEEE32BitWord! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:27:09.002'!
intAt: index
	^ ((self uintAt: index) bitInvert32 + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:24:24.582'!
intAt: index put: anInteger
	self uintAt: index put: (anInteger bitInvert32 + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:33:34.4'!
longAt: index
	^ (((self ulongAt: index) bitXor: 16rFFFFFFFFFFFFFFFF) + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:29:04.776'!
longAt: index put: anInteger
	^ self ulongAt: index put: ((anInteger bitXor: 16rFFFFFFFFFFFFFFFF) + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:29:35.08'!
ucharAt: index
	^ ((self byteAt: index) bitInvert + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/29/2013 11:31:39.202'!
ucharAt: index put: aByte
	self byteAt: index put: (aByte bitInvert + 1) negated! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 12:10:40.646'!
uintAt: index
	| n |
	n := 0.
	3 to: 0 by: -1 do: [ :i |
		n := (n bitShift: 8) + (self byteAt: index + i)
	].
	^ n! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'WS 5/22/2013 17:21:27.09'!
uintAt: index put: anInteger
	3 to: 0 by: -1 do: [ :i |
		self byteAt: index + i put: (anInteger digitAt: i + 1).
	]! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'RL 5/22/2013 13:23:39.95'!
ulongAt: index
	| n |
	n := 0.
	7 to: 0 by: -1 do: [ :i |
		n := (n bitShift: 8) + (self byteAt: index + i)
	].
	^ n! !

!ByteArray methodsFor: '*MemoryMentor-Core' stamp: 'WS 5/22/2013 17:21:11.238'!
ulongAt: index put: anInteger
	7 to: 0 by: -1 do: [ :i |
		self byteAt: index + i put: (anInteger digitAt: i+1).
	]! !

SystemWindow subclass: #MMMemoryMentor
	instanceVariableNames: 'ui uiContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMMemoryMentor methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:08:15.804'!
changeTask: aTask
	Transcript show: 'Selected Task: ', aTask name; cr! !

!MMMemoryMentor methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:07:01.11'!
createTaskTree
	ui tasks
		model: MMTaskTreeModel new;
		addColumn: (UiItemViewSimpleColumnSpec newFrom: {
			#headerText -> 'Tasks'.
			#text -> #name.
		}).
	self connect: ui tasks signal: #selectionChanged: toSelector: #itemsSelected:! !

!MMMemoryMentor methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 11:44:14.382'!
initialize
	super initialize.
	self
		model: Model new;
		setLabel: 'Memory Mentor'.
	uiContainer := Morph new.
	self addMorph: uiContainer frame: (0@0 corner: 1@1).
	ui := MMMemoryMentorUi new.
	ui setupUi: uiContainer.
	self
		createTaskTree! !

!MMMemoryMentor methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 15:07:58.832'!
itemsSelected: items
	items first isTask ifTrue: [ self changeTask: items first ]
	! !

TestCase subclass: #MMByteArrayExtensionTest
	instanceVariableNames: 'bytes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:37:54.472'!
compare: byteArray atPosition: anInteger
	^ (bytes copyFrom: anInteger to: anInteger + byteArray size - 1) = byteArray! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 11:38:34.118'!
setUp
	bytes := #[110 166 99 74 251 33 9 64 190 0 254 240 66 255 1 255 66 69 1 53 65 69 1 245 190 186 254 202 190 186 254 202 80 250 72 56 0 0 188 65 1 42 0 0 0 0 0 0]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:13:09.758'!
testBool
	self assert: [ (bytes boolAt: 40+1) = true ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:14:41.122'!
testBoolStore
	| byteArray |
	byteArray := ByteArray new: 1.
	byteArray boolAt: 1 put: true.
	self assert: [ self compare: byteArray atPosition: 40+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:31:42.152'!
testChar
	self assert: [ (bytes charAt: 32+1) = $P asInteger ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:16:31.042'!
testCharStore
	| byteArray |
	byteArray := ByteArray new: 1.
	byteArray charAt: 1 put: $P.
	self assert: [ self compare: byteArray atPosition: 32+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:43.294'!
testDouble
	self assert: [ ((bytes doubleAt: 0+1) - 3.14159258) abs < 0.00001 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'WS 6/4/2013 16:50:12.936'!
testDoubleStore
	| byteArray |
	byteArray := ByteArray new: 8.
	byteArray doubleAt: 1 put: 3.14159258.
	self assert: [ self compare: byteArray atPosition: 0+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:14:10.732'!
testFloat
	self assert: [ (bytes floatAt: 36+1) = 23.5 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:18:32.588'!
testFloatStore
	| byteArray |
	byteArray := ByteArray new: 4.
	byteArray floatAt: 1 put: 23.5.
	self assert: [ self compare: byteArray atPosition: 36+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:23.3'!
testInt
	self assert: [ (bytes intAt: 8+1) = -251789122 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:19:08.378'!
testIntStore
	| byteArray |
	byteArray := ByteArray new: 4.
	byteArray intAt: 1 put: -251789122.
	self assert: [ self compare: byteArray atPosition: 8+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:24:52.984'!
testLong
	self assert: [ (bytes longAt: 16+1) = -792275913076030142 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:19:40.604'!
testLongStore
	| byteArray |
	byteArray := ByteArray new: 8.
	byteArray longAt: 1 put: -792275913076030142.
	self assert: [ self compare: byteArray atPosition: 16+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:32:12.53'!
testUChar
	self assert: [ (bytes ucharAt: 33+1) = 250 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/29/2013 11:31:20.054'!
testUCharStore
	| byteArray |
	byteArray := ByteArray new: 1.
	byteArray ucharAt: 1 put: 250.
	self assert: [ self compare: byteArray atPosition: 33+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 12:13:13.44'!
testUint
	self assert: [ (bytes uintAt: 12+1) = 4278320962 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:34:55.044'!
testUintStore
	| byteArray |
	byteArray := ByteArray new: 4.
	byteArray uintAt: 1 put: 4278320962.
	self assert: [ self compare: byteArray atPosition: 12+1 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 12:13:51.114'!
testUlong
	self assert: [ (bytes ulongAt: 24+1) = 14627333968358193854 ]! !

!MMByteArrayExtensionTest methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:38:49.828'!
testUlongStore
	| byteArray |
	byteArray := ByteArray new: 8.
	byteArray ulongAt: 1 put: 14627333968358193854.
	self assert: [ self compare: byteArray atPosition: 24+1 ]! !

TestCase subclass: #MMFloatExtensionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMFloatExtensionTest methodsFor: 'as yet unclassified' stamp: 'lt 5/31/2013 15:58:52.867'!
testDouble

	| value |
	value := Float fromIEEE64Bit: 16r40B3881F9ADD3739.
	self assert: (5000.12345 - value) abs < 0.1.
	! !

TestCase subclass: #MMMemoryCellTest
	instanceVariableNames: 'memory startAddress size cell address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:41:45.706'!
setUp
	startAddress := 16r1000.
	address := startAddress + 4.
	memory := MMMemory withStartAddress: startAddress bytes: #(1 2 3 4 5 6 7 8 9 10 11 12).
	
	cell := MMMemoryCell at: address in: memory! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:42:31.55'!
testAccess
	self assert: [ (cell byteAt: 0) == 5 ].
	self assert: [ (cell byteAt: 1) == 6 ].
	self assert: [ (cell byteAt: 2) == 7 ].
	self assert: [ (cell byteAt: 3) == 8 ].! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:45:00.558'!
testInitialization
	self assert: [ cell address == address ].
	self assert: [ cell memory == memory ]! !

TestCase subclass: #MMMemoryTest
	instanceVariableNames: 'startAddress size memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 15:58:14.152'!
expectedFailures
	^ #(testIntegerData)! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:01:05.856'!
setUp
	startAddress := 4096.
	size := 4.
	memory := MMMemory withStartAddress: startAddress cellCount: size! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:09:14.552'!
testByteData
	memory at: startAddress putByteArray: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	
	1 to: size * 4 do: [ :index |
		self assert: [ (memory byteAt: (index - 1 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:06:38.408'!
testCellAccess
	self shouldnt: [ memory cellAtAddress: startAddress + 4 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 4) address == (startAddress + 4) ].
	
	self shouldnt: [ memory cellAtAddress: startAddress + 12 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 12) address == (startAddress + 12) ].
	
	self should: [ memory cellAtAddress: startAddress - 4 ] raise: Exception.
	
	self should: [ memory cellAtAddress: startAddress + (size * 4) ] raise: Exception
! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 15:07:50.83'!
testCellIteration
	| cellIndex |
	cellIndex := 0.
	
	memory cellsDo: [ :cell |
		self assert: [ cell address == (4*cellIndex + startAddress) ].
		cellIndex := cellIndex + 1
	].
	
	self assert: [ cellIndex == size ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:27:44.958'!
testEquality
	| secondMemory bytes |
	
	bytes := #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	memory at: startAddress putByteArray: bytes.
	secondMemory := MMMemory withStartAddress: startAddress bytes: bytes.
	
	self assert: [ memory = secondMemory ].! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:11:49.834'!
testInitialization
	self assert: [ memory startAddress == startAddress ].
	self assert: [ memory cellCount == size ].
	self assert: [ memory byteSize == (size * MMMemoryCell size)].
	self assert: [ memory endAddress == (startAddress + (4 * size)) ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 15:57:29.258'!
testIntegerData
	memory at: startAddress putInt: 1.
	memory at: startAddress+4 putInt: 2.
	memory at: startAddress+8 putInt: 3.
	memory at: startAddress+12 putInt: 4.
	
	1 to: size do: [ :index |
		self assert: [ (memory intAt: (index - 1 * 4 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 11:15:02.816'!
testLongData
	self shouldnt: [ memory at: startAddress putByteArray: (1 to: 20) asArray ] raise: Exception.
	self assert: [ memory cellCount == size ]! !

TestCase subclass: #MMRightAngledArrowTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMRightAngledArrowTest methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 14:05:05.36'!
arrowFrom: aPoint to: anotherPoint shouldHavePoints: aCollection
	self assert: [ (MMRightAngledArrow from: aPoint to: anotherPoint spacing: 30) points asArray = aCollection asArray ]! !

!MMRightAngledArrowTest methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 15:55:26.486'!
testPoints
	self arrowFrom: 0@0 to: 0@10 shouldHavePoints: { 0@0. 0@10 }.
	self arrowFrom: 0@0 to: 0@50 shouldHavePoints: { 0@0. 30@0. 30@50. 0@50 }.
	self arrowFrom: 0@0 to: 50@0 shouldHavePoints: { 0@0. 0@30. 50@30. 50@0 }.
	self arrowFrom: 0@0 to: 100@50 shouldHavePoints: { 0@0. 50@0. 50@50. 100@50 }.! !

TestCase subclass: #MMValueMorphTest
	instanceVariableNames: 'valueMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 5/23/2013 15:51:28.901'!
setUp
	valueMorph := MMValueMorph new! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:09.577'!
testAscii
	valueMorph 
		displayMode: #ascii; 
		content: 83.
	self assert: 'S' printString equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:12.535'!
testNegativeBinary
	valueMorph 
		displayMode: #binary; 
		content: -2r10010011.
	self assert: '-10010011b' equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:20.761'!
testNegativeDecimal
	valueMorph 
		displayMode: #decimal; 
		content: -33.
	self assert: '-33' equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:00.627'!
testNegativeHex
	valueMorph 
		displayMode: #hexadecimal; 
		content: 16r-cafebabe.
	self assert: '-0xCAFEBABE' equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:23.084'!
testPositiveBinary
	valueMorph 
		displayMode: #binary; 
		content: 2r10010011.
	self assert: '10010011b' equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:25.402'!
testPositiveDecimal
	valueMorph 
		displayMode: #decimal; 
		content: 100.
	self assert: '100' equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:27.993'!
testPositiveHex
	valueMorph 
		displayMode: #hexadecimal; 
		content: 16rbabebabe.
	self assert: '0xBABEBABE' equals: valueMorph contentString ! !

!MMValueMorphTest methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 15:21:30.382'!
testVeryHighPositiveBinary
	valueMorph 
		displayMode: #binary; 
		content: 2r1111111100000000111111110000000011111111000000001111111100000000.
	self assert: '1111111100000000111111110000000011111111000000001111111100000000b' equals: valueMorph contentString ! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAddress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:14.594'!
withStartAddress: startAddress bytes: aByteArray

	^ self 
		withStartAddress: startAddress 
		bytes: aByteArray 
		cellCount: (aByteArray size / 4) ceiling! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:30.614'!
withStartAddress: startAddress bytes: aByteArray cellCount: aNumber
	|instance|
	instance := self withStartAddress: startAddress cellCount: aNumber.
	instance at: startAddress putByteArray: aByteArray.
	^ instance! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:17:01.288'!
withStartAddress: startAddress cellCount: aNumber
	^ self new
		initializeWithStartAddress: startAddress cellCount: aNumber;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:32:29.536'!
= anotherMMMemory
	self class == anotherMMMemory class ifFalse: [ ^ false ].
	startAddress == anotherMMMemory startAddress ifFalse: [ ^ false ].
	
	^ memory = anotherMMMemory memory! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:31:02.124'!
at: address putByte: byte
	memory byteAt: (self indexForAddress: address) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:27:13.602'!
at: address putByteArray: byteArray
	(byteArray size > (cells size * 4) ifTrue: [ byteArray first: cells size * 4 ] ifFalse: [ byteArray ])
		withIndexDo: [ :byte :index |
		self at: address+index-1 putByte: (byteArray at: index)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:11.56'!
at: address putInt: int
	memory intAt: (self indexForAddress: address) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:40:08.552'!
at: address putULong: unsignedLong
	memory ulongAt: (self indexForAddress: address) put: unsignedLong! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:25:05.046'!
byteAt: adress
	 ^ memory at: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:14:26.12'!
cellAtAddress: address
	^ cells at: (self cellIndexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:43.905'!
cellCount
	^ cells size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:13:45.782'!
cellIndexForAddress: address
	^ ((address roundDownTo: 4) - startAddress)/4 + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:36:41.85'!
charAt: adress
	 ^ memory charAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/31/2013 11:29:42.957'!
doubleAt: adress
	 ^ memory doubleAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:54:00.067'!
endAddress
	^ startAddress + (self cellCount * MMMemoryCell size)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 14:20:02.262'!
floatAt: adress
	 ^ memory floatAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:46.656'!
indexForAddress: address
	^ address - startAddress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:16:31.907'!
initializeWithStartAddress: adress cellCount: aNumber
	startAddress := adress.
	memory := ByteArray new: aNumber*4.
	cells := OrderedCollection new.
	1 to: aNumber do: [ :i |
		cells add: (MMMemoryCell at: (4*(i-1) + startAddress) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:31.124'!
intAt: address
	 ^ memory intAt: (self indexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:36:56.576'!
longAt: adress
	 ^ memory longAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/15/2013 10:32:06.59'!
memory
	^ memory! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:09.978'!
startAddress
	^ startAddress! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:36:45.804'!
ucharAt: adress
	 ^ memory ucharAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:37:11.5'!
uintAt: adress
	 ^ memory uintAt: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/22/2013 13:37:00.826'!
ulongAt: adress
	 ^ memory ulongAt: (self indexForAddress: adress)! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'address memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:46.536'!
at: address in: memory
	 ^ self new
		initializeWithAddress: address andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:11.996'!
address
	^ address! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:22:27.266'!
byteAt: index
	^ memory byteAt: address + index! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:28.346'!
initializeWithAddress: anAddress andMemory: aMemory
	address := anAddress.
	memory := aMemory! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:00.459'!
memory
	^ memory! !

Object subclass: #MMPointerArrow
	instanceVariableNames: 'arrow fromCell toCell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMPointerArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:03:35.058'!
from: aMemoryCell
	^ self
		from: aMemoryCell
		to: nil! !

!MMPointerArrow class methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:03:40.86'!
from: aMemoryCell to: anotherMemoryCell
	^ super new
		fromCell: aMemoryCell;
		toCell: anotherMemoryCell;
		yourself! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:02:26.484'!
fromCell
	^ fromCell! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:22:55.612'!
fromCell: aMemoryCell
	fromCell ifNotNil: [ fromCell removePointerArrow: self ].
	fromCell := aMemoryCell.
	
	fromCell ifNotNil: [
		fromCell pointerArrow: self.
		arrow := MMRightAngledArrow from: fromCell rightCenter to: self currentWorld currentHand center.
		arrow openInWorld
	]! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:04:01.962'!
handleListenEvent: evt
	toCell ifNil: [
		arrow ifNotNil: [
			arrow initializeFrom: fromCell rightCenter to: evt position
		]
	].
	
	(evt isMouseUp) ifTrue: [ | morphs |
		self currentWorld currentHand removeMouseListener: self.
		
		morphs := self currentWorld morphsAt: evt position.
		(morphs detect: [ :morph | morph isKindOf: MMCellGroupMorph ] ifNone: [ nil ]) ifNil: [
			fromCell clearPointerArrow.
		] ifNotNil: [ :cellGroupMorph |
			self toCell: cellGroupMorph.
		]
	]! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:48:45.9'!
initialize
	super initialize.
	
	self currentWorld currentHand addMouseListener: self! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 13:53:11.372'!
remove
	arrow delete! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 14:02:47.636'!
toCell
	^ toCell! !

!MMPointerArrow methodsFor: 'as yet unclassified' stamp: 'WS 5/22/2013 17:10:53.382'!
toCell: aMemoryCell
	toCell := aMemoryCell.
	
	toCell ifNotNil: [
		self currentWorld currentHand removeMouseListener: self.
		
		arrow ifNotNil: [
			arrow initializeFrom: fromCell rightCenter to: toCell rightCenter
		].
		
		fromCell retargetedPointer: toCell
	]! !

Object subclass: #MMTaskTreeModel
	uses: TUiItemModel
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Core'!

MMTaskTreeModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!MMTaskTreeModel methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:30:23.564'!
createHierarchy
	^ {
		MMTopic pointers.
		MMTopic objects.
		MMTopic pointers.
	}
	! !

!MMTaskTreeModel methodsFor: 'item model - hierarchy' stamp: 'RL 6/5/2013 13:45:33.44'!
data
	^ data! !

!MMTaskTreeModel methodsFor: 'item model - hierarchy' stamp: 'RL 6/5/2013 13:40:04.898'!
groups
	^ #(data)! !

!MMTaskTreeModel methodsFor: 'as yet unclassified' stamp: 'RL 6/5/2013 14:16:28.518'!
initialize 
	super initialize.
	data := self createHierarchy! !

UiTextMorph subclass: #MMContentMorph
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

MMContentMorph subclass: #MMBitsMorph
	instanceVariableNames: 'byteLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMBitsMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:32:59.748'!
content: numberValue extent: aRectangle byteLength: numberOfBytes
	^ self new
		extent: aRectangle;
		byteLength: numberOfBytes;
		content: numberValue;
		yourself! !

!MMBitsMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 12:04:11.673'!
defaultFont

	^ StrikeFont familyName: 'Bitmap Envy Code R' pointSize: 9 emphasized: 2! !

!MMBitsMorph methodsFor: 'accessing' stamp: 'lt 6/5/2013 10:36:17.588'!
byteLength
	^ byteLength! !

!MMBitsMorph methodsFor: 'accessing' stamp: 'lt 6/5/2013 10:36:17.597'!
byteLength: anObject
	byteLength := anObject! !

!MMBitsMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:03:03.557'!
contentString
	| paddedBinaryRepresentation currentIndex |
	paddedBinaryRepresentation := (content printStringBase: 2) 
		padded: #left 
		to: 8 * byteLength 
		with: $0.
	
	currentIndex := 0.
	^ paddedBinaryRepresentation inject: '' into: 
		[ :result :each | |separator|
		separator := (currentIndex ~= 0 and: [currentIndex isDivisibleBy: 8]) 
			ifTrue: [' '] 
			ifFalse: [''].
		currentIndex := currentIndex + 1. 
		result , separator , each ].! !

!MMBitsMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:56:31.358'!
initialize 
	super initialize.
	self 
		font: self class defaultFont;
		centered! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:02:02.016'!
content
	^ content! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:02:41.28'!
content: anInteger
	content := anInteger.
	self updateContentString ! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:03:03.553'!
contentString
	^ self subclassResponsibility.! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 13:38:13.152'!
initialize
	super initialize.

	self 
		backgroundColor: (Color gray: 0.9);
		layoutPolicy: TableLayout new;
		listDirection: #lefttoRight;
		listCentering: #center;
		editView: Morph new;
		readOnly: true! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 10:40:08.684'!
mouseUp: evt
	editor ifNotNil: [:e | super mouseUp: evt].! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:03:03.564'!
updateContentString
	self contentsWrapped: self contentString! !

!MMContentMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 10:39:52.65'!
yellowButtonActivity: shiftKeyState
	self owner yellowButtonActivity: shiftKeyState! !

MMContentMorph subclass: #MMValueMorph
	instanceVariableNames: 'displayMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Visualization'!

!MMValueMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:31:18.952'!
content: aNumber extent: aRectangle displayMode: aSymbol
	^ self new
		extent: aRectangle;
		displayMode: aSymbol;
		content: aNumber;
		yourself! !

!MMValueMorph class methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 11:55:31.616'!
defaultFont

	^ StrikeFont familyName: 'Bitmap Envy Code R' pointSize: 10 emphasized: 0! !

!MMValueMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:30:30.952'!
displayModes
	^ #(ascii binary decimal hexadecimal)! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:03:03.541'!
contentString
	^ (displayMode caseOf: {
		[ #decimal ] -> [ content printString ].
		[ #binary ] -> [ ((content printStringBase: 2) padded: #left to: 8 with: $0), 'b' ].
		[ #hexadecimal ] -> [(content positive ifTrue: [''] ifFalse: ['-']) , 
				'0x', (content abs printStringBase: 16) padded: #left to: 2 with: $0 ].
		[ #ascii ] ->[ content >= 32
				ifTrue:[ (Character value: content) asString printString ]
				ifFalse: [ ('\', content asString) printString ] ].
	})! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/15/2013 13:34:39.726'!
displayMode
	 ^ displayMode! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:02:41.292'!
displayMode: aSymbol
	(self class displayModes includes: aSymbol)
		ifFalse: [ self error: 'invalid display mode' ].
	displayMode := aSymbol.
	self updateContentString ! !

!MMValueMorph methodsFor: 'as yet unclassified' stamp: 'lt 6/5/2013 14:23:34.25'!
initialize 
	super initialize.
	self 
		displayMode: #decimal;
		font: self class defaultFont;
		content: 0;
		centered.

	self updateContentString ! !
